
var totalData = {};

function initializeData(data){
	totalData = data;
	createDesciplineDropdown(totalData);
}

function createDesciplineDropdown(totalDatab){	
	var datat = totalDatab.discipline;

	var selectb = document.getElementById('searchByDiscipline');
	for (var prop in datat) {
		var option = document.createElement("option");
			option.value = datat[prop];
			option.text = datat[prop];
			selectb.appendChild(option);	
	}	
	
}


var headingDivRow = document.createElement("DIV");
headingDivRow.setAttribute("class", "heading-div");

var divColSm6 = document.createElement("DIV");
divColSm6.setAttribute("class", "filtersDiv");	


divColSm6.innerHTML = 'Filters: <input type="text" id="searchByTitle" placeholder="Search Projects" class="radius0 search-input search_title_desc" onkeyup="filterByTitle(this.value)" /> <input type="text" id="searchBySupervisor" placeholder="Search By Supervisor" class=" radius0 search-input" onkeyup="filterBySupervisor(this.value)" /> <select id="searchByDiscipline" class=" radius0 select-box" onchange="filterByDiscipline(this.value)" ><option value="">Search By Discipline</option></select> <input type="button" class="reset" value="Reset" onClick="reset_all()" />';

			

headingDivRow.appendChild(divColSm6);


var div2ColSm6 = document.createElement("DIV");
div2ColSm6.setAttribute("class", "resultsDiv");

//div2ColSm6.innerHTML = 'Results: <span id="dataCount">'+ (totalData.result.length) +' </span> found';
div2ColSm6.innerHTML = 'Results: <span id="dataCount"> </span> found';

divColSm6.appendChild(div2ColSm6);		

document.getElementById(elementId).appendChild(headingDivRow);

var messageSpan = document.createElement("SPAN");
messageSpan.setAttribute("id", "messageSpan");
document.getElementById(elementId).appendChild(messageSpan);

var parentMainDivRow = document.createElement("DIV");
parentMainDivRow.setAttribute("id", "parentMainDivRow");

function showSheetData(myObj, paginationCount, isFirst = 1, pageNo = 1) {			

	if(myObj.status == 1)
	{
		var maxIteration = myObj.result.length;
		
		document.getElementById('dataCount').innerText = paginationCount.result.length;
						
		if(isFirst){
			maxIteration = myObj.result.length < totalRowsPerpage ? myObj.result.length : totalRowsPerpage;
		}
				

		for (i = 0; i < maxIteration; i++) {
			
			var mainDivRow = document.createElement("DIV");
			mainDivRow.setAttribute("data-title", myObj.result[i].project_title);
			mainDivRow.setAttribute("data-supervisor", myObj.result[i].supervisor);
			mainDivRow.setAttribute("class", "mainRow");
			
			var divColSm12 = document.createElement("DIV");
			divColSm12.setAttribute("class", "group_details");
			
			var projectTitle = document.createElement("H4");
			projectTitle.innerText = myObj.result[i].project_title;
			divColSm12.appendChild(projectTitle);
			
			var Description = document.createElement("P");
			Description.innerText = myObj.result[i].description;
			divColSm12.appendChild(Description);
			
			var Supervisor = document.createElement("P");
			Supervisor.innerHTML = "<strong>Senior Supervisor:</strong><br>" +myObj.result[i].supervisor;
			divColSm12.appendChild(Supervisor);
			
			var Group = document.createElement("P");
			Group.setAttribute("class", "group_name");
			Group.innerHTML = "<strong>Associate Supervisor(s):</strong> " + myObj.result[i].group;
			divColSm12.appendChild(Group);
			
			var Discipline = document.createElement("P");
			Discipline.innerHTML = "<strong>Discipline:</strong> " + myObj.result[i].discipline;
			divColSm12.appendChild(Discipline);
				
	
			//selectb.options.add( new Option(myObj.result[i].discipline,myObj.result[i].discipline) );
			
			// var Group = document.createElement("P");
			// Group.setAttribute("class", "group_name");
			// Group.innerHTML = "<strong>Group:</strong> " + myObj.result[i].group;
			// divColSm12.appendChild(Group);
			
			var Campus = document.createElement("P");
			Campus.innerHTML = "<strong>Campus:</strong> " + myObj.result[i].campus;
			divColSm12.appendChild(Campus);
			
			var ProgramCode = document.createElement("P");
			ProgramCode.innerHTML = "<strong>Program Code:</strong> " + myObj.result[i].program_code;
			divColSm12.appendChild(ProgramCode);
			
			var Positions = document.createElement("P");
			Positions.innerHTML = "<strong>Positions:</strong> " + myObj.result[i].positions;
			divColSm12.appendChild(Positions);
			
			var Contact_Details = document.createElement("P");
			Positions.innerHTML = "<strong>Additional information:</strong> " + myObj.result[i].contact_details;
			divColSm12.appendChild(Contact_Details);
			
			mainDivRow.appendChild(divColSm12);
			
			/*var hrLine = document.createElement("HR");
			mainDivRow.appendChild(hrLine);*/
			
			parentMainDivRow.appendChild(mainDivRow);			
			
		}
		
		document.getElementById(elementId).appendChild(parentMainDivRow);
		
		if(paginationCount.result.length > totalRowsPerpage){
			var _mainDivRow = document.createElement("DIV");	
			_mainDivRow.setAttribute("class", "paginationMainDiv");
			
			var _span = document.createElement("SPAN");	
			_span.innerHTML = "<strong>Page:</strong> "
			_mainDivRow.appendChild(_span);	
			
			var _ul = document.createElement("UL");	
			_ul.setAttribute("class", "pagination");
			
			_mainDivRow.appendChild(_ul);	

			
			var totalPaginationNo = ((paginationCount.result.length)/totalRowsPerpage);
			
			//maxPaginationNo = totalPaginationNo < maxPaginationButton ? totalPaginationNo : maxPaginationButton;
			maxPaginationNo = totalPaginationNo;
			
			var startPosition = 0;
			for (i = 0; i < maxPaginationNo; i++) {
				
				var _li = document.createElement("LI");
				var _a = document.createElement("A");
				if((i+1) == pageNo){
					_a.setAttribute("class", "active");
				}
				
				_a.setAttribute("onclick", "showPaginatedData("+JSON.stringify(paginationCount)+", "+startPosition+", "+(startPosition+totalRowsPerpage)+", "+(i+1)+");");
				
				_a.innerText = i+1;
				_li.appendChild(_a);
				_ul.appendChild(_li);
				
				startPosition = startPosition+totalRowsPerpage;
			}
					
			parentMainDivRow.appendChild(_mainDivRow);		
		}
	}
	else
	{
		document.getElementById(elementId).innerHTML = "Data not found";
	}
}


function showPaginatedData(paginationCount, startPosition, endPosition, pageNo){
	document.getElementById("parentMainDivRow").innerHTML = '';
		
	var myarr = [];
	myarr = paginationCount.result; 
	
	var aa = [];
	aa = myarr.slice(startPosition, endPosition);
		
	newSubArray = {
		status: 1,
		result: aa
	};	
	
	showSheetData(newSubArray, paginationCount, 0, pageNo);
	(function smoothscroll(){
		var currentScroll = document.documentElement.scrollTop || document.body.scrollTop;
		if (currentScroll > 0) {
			 window.requestAnimationFrame(smoothscroll);
			 window.scrollTo (500, 0);
		}
	})();
	
}





function filterByTitle(titleValue){
	
	document.getElementById('searchBySupervisor').value = "";
	document.getElementById('searchByDiscipline').value = "";
	
	var newFilteredArray = totalData.result.filter( function(value, index, array){
		if(value.project_title.toLowerCase().indexOf(titleValue.toLowerCase()) >= 0 || value.description.toLowerCase().indexOf(titleValue.toLowerCase()) >= 0){
			return true;
		}else{
			return false;
		}
	} );
		
	var count = newFilteredArray.length;	
	
	document.getElementById('dataCount').innerText = count;	
	if(count === 0){
		document.getElementById('messageSpan').innerText = "No records found.";	
	}else{
		document.getElementById('messageSpan').innerText = "";	
	}
	
	newFilteredObject = {
		status: 1,
		result: newFilteredArray
	}
	document.getElementById("parentMainDivRow").innerHTML = '';
	showSheetData(newFilteredObject, newFilteredObject, 1);
}

function filterBySupervisor(supervisorValue){
	document.getElementById('searchByTitle').value = "";
	document.getElementById('searchByDiscipline').value = "";
	
	var newFilteredArray = totalData.result.filter( function(value, index, array){
		if(value.supervisor.toLowerCase().indexOf(supervisorValue.toLowerCase()) >= 0){
			return true;
		}else{
			return false;
		}
	} );
		
	var count = newFilteredArray.length;	
	
	document.getElementById('dataCount').innerText = count;	
	if(count === 0){
		document.getElementById('messageSpan').innerText = "No records found.";	
	}else{
		document.getElementById('messageSpan').innerText = "";	
	}
	
	newFilteredObject = {
		status: 1,
		result: newFilteredArray
	}
	document.getElementById("parentMainDivRow").innerHTML = '';
	showSheetData(newFilteredObject, newFilteredObject, 1);
}


function filterByDiscipline(disciplineValue){
	
	document.getElementById('searchByTitle').value = "";
	document.getElementById('searchBySupervisor').value = "";
	
	var e = document.getElementById("searchByDiscipline");
	var strUser = e.options[e.selectedIndex].value;		
	

	var newFilteredArray = totalData.result.filter( function(value, index, array){
		if(value.discipline.toLowerCase().indexOf(disciplineValue.toLowerCase()) >= 0){
			return true;
		}else{
			return false;
		}
	} );
		
	var count = newFilteredArray.length;
	
	document.getElementById('dataCount').innerText = count;	
	if(count === 0){
		document.getElementById('messageSpan').innerText = "No records found.";	
	}else{
		document.getElementById('messageSpan').innerText = "";	
	}
	
	newFilteredObject = {
		status: 1,
		result: newFilteredArray
	}
	document.getElementById("parentMainDivRow").innerHTML = '';
	showSheetData(newFilteredObject, newFilteredObject, 1);
	
}
function reset_all(){	
	document.getElementById('searchByTitle').value = "";
	document.getElementById('searchBySupervisor').value = "";
	document.getElementById('searchByDiscipline').value = "";
	location.reload(); 	
}

 var script = document.createElement("script");
    script.src = "https://hdrprojects.its.rmit.edu.au/phdprojects-cfb/gApi/index.php?sheet_name="+sheetName; 
    //script.src = "//192.168.5.148/jqueryscript/gApi/index.php?sheet_name="+sheetName; 
    document.head.appendChild(script);
	
